
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>APP账号密码传输安全分析 / 憋错料</title>

    <meta name="description" content="APP账号密码传输安全分析 最近在搞公司的安卓APP测试(ThinkDrive 企邮云网盘)测试,安卓app测试时使用代理抓包,发现所此app使用HTTP传输账号密码,且密码只是普通MD5加密,存在安全隐患,无法防止sniffer攻击.中间人攻击(因此这次安全问题,加强对这两安全术语的了解): 问题1:账号密码采用http传输,账号与密码(MD5值)均可以捕获: 问题2:密码虽采用MD5加密,简单密码可以在线解密: 问题3:密码不解密也一样可以登录,通过A账号在app登录,再用sniffer得到的B 帐号与密码(MD5值)">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">APP账号密码传输安全分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>最近在搞公司的安卓APP测试(ThinkDrive 企邮云网盘)测试，安卓app测试时使用代理抓包，发现所此app使用HTTP传输账号密码，且密码只是普通MD5加密，存在安全隐患，<strong>无法防止sniffer攻击、中间人攻击</strong>（因此这次安全问题，加强对这两安全术语的了解）：</p>
<p>问题1：账号密码采用http传输，账号与密码(MD5值)均可以捕获；</p>
<p>问题2：密码虽采用MD5加密，简单密码可以在线解密；</p>
<p>问题3：密码不解密也一样可以登录，通过A账号在app登录，再用sniffer得到的B&nbsp;帐号与密码（MD5值），使用Fiddler修改A账号的请求完成B账号在APP登录</p>

<p>公司邮箱各版本其实使用的也是明文传输，最近WEB虽采用了HTTPS传输，但仍是传输的明文，可以抓包查看（HTTPS也可通过Fiddler解析成明文），基于此原因，于是对主流邮箱登录进行抓包分析，本文主要分析QQ是如何把账号密码从客户端传到服务端，学习借鉴相关经验。</p>

<p>===========分析结果（Findyou）===============</p>
<p>【QQ触屏版】</p>
<p>测试帐号：2198400585</p>
<p>用户密码：123qwe</p>
<p>加密方法：RSA非对称加密</p>
<p>传输协议：HTTPS</p>

<p>【WEB版】</p>
<p>测试帐号：2198400585</p>
<p>用户密码：123qwe</p>
<p>加密方法：MD5(hexchar2bin(MD5(密码))+QQ号16进制)+<strong>验证码</strong>)</p>
<p>传输协议：HTTPS</p>
<p>分析结论：使随机<strong>验证码</strong>混合MD5加密以保证每次登录的值不一样</p>
<p>===========分析结果（Findyou）===============</p>


<ul>
<li><strong>【QQ触屏版分析】</strong></li>
</ul>

<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwNDA1MS8yMDEzMDgvMDgwMDMxMTAtNDg1NTc2Mjk0MmFkNDRmYWEyZjMwYmUwZTI4MDY4ZjQuanBn.jpg"></p>



<p>操作步骤：1.使用Chrome修改浏览器User Agent为iphone</p>
<p>2.打开Fiddler准备抓包</p>
<p>3.访问mail.qq.com，QQ会自动适配到触屏版</p>
<p>4.查看<a href="http://w.mail.qq.com/cgi-bin/loginpage?f=xhtml" rel="external nofollow noreferrer">http://w.mail.qq.com/cgi-bin/loginpage?f=xhtml</a>源码</p>
<p>得到关键代码如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>    loginForm.onsubmit = function(){
        var pwd = document.getElementById("pwd");
        var p = document.getElementById("p");
        var tsValue = document.getElementById("ts").value;
        var PublicKey = "CF87D7B4C864F4842F1D337491A48FFF54B73A17300E8E42FA365420393AC0346AE55D8AFAD975DFA175FAF0106CBA81AF1DDE4ACEC284DAC6ED9A0D8FEB1CC070733C58213EFFED46529C54CEA06D774E3CC7E073346AEBD6C66FC973F299EB74738E400B22B1E7CDC54E71AED059D228DFEB5B29C530FF341502AE56DDCFE9";
            var RSA = new RSAKey();
            RSA.setPublic(PublicKey, "10001");
        var Res = RSA.encrypt(pwd.value+ ‘\n‘ + tsValue + ‘\n‘);
        if (Res)
        {
            p.value = hex2b64(Res);
            pwd.value = "";
        }
        return true;
    }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><strong>如此可以看使用加密方法：&nbsp;RSA公钥加密算法</strong></p>
<p>Fiddler抓包如下：（P为密码加密后的值）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwNDA1MS8yMDEzMDgvMDgwMDM0MDYtMTljOTM0N2E3ZjVjNGVkZmE4MTcwN2ZkZTczOWM4MzAuanBn.jpg"></p>





<ul>
<li><strong>【WEB版分析】</strong></li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwNDA1MS8yMDEzMDgvMDgwMDM3MzctYzU3ZDg1ZGIwZmJlNDViODgwZmU4OWEyYjdiZTRkZGMucG5n.jpg"></p>

<p>注：网上查阅众多相关资料（网上有许多介绍QQ登录相关的内容），总结实践测试截图抓包如下</p>

<p><strong>Step1: &nbsp;打开mail.qq.com，向服务器 获取验证码</strong></p>
<p>捕获请求：</p>
<p>https://ssl.ptlogin2.qq.com/[email&#160;protected]&amp;appid=522005705&amp;ptlang=2052&amp;js_type=2&amp;js_ver=10009&amp;r=0.8771616001613438</p>
<p>返回数据有两种情况:</p>
<p>1). ptui_checkVC(‘1‘,‘aabf7b95f41689c5872740515288dcb5b1911c3de95f2092‘,‘\x00\x00\x00\x00\x83\x08\xee\x49‘);</p>
<p>2). ptui_checkVC(‘0‘,‘!BQI‘,‘\x00\x00\x00\x00\x83\x08\xee\x49‘);</p>
<p>其中 ‘1’代表需要验证码，‘0’代表不需要验证码 ，‘!BQI‘ 就是默认的验证码；</p>

<p><strong>Step2: 密码加密</strong></p>
<p>腾讯JS加密代码：</p>
<p>M=C.p.value;</p>
<p>var I=hexchar2bin(md5(M));</p>
<p>var H=md5(I+pt.uin);</p>
<p>var G=md5(H+C.verifycode.value.toUpperCase());</p>

<p>密码“123qwe”通过以上加密方法，得到的结果与抓包请求中的加密值一样（请求截图见Step3）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwNDA1MS8yMDEzMDgvMDgwMDQxMjYtNzE3MGIxYzQ4ZGFkNDA0MDgyNzcxZjJiNjc4ZWM2YzcuanBn.jpg"></p>
<p>pt.uin =&nbsp;&nbsp;\x00\x00\x00\x00\x83\x08\xee\x49 &nbsp; &nbsp;&nbsp;QQ号&nbsp;2198400585的16进制&nbsp;000000008308ee49</p>


<p><strong>Step3：登录请求</strong></p>
<p>捕获请求：&nbsp;<strong><br /></strong></p>
<p>https://ssl.ptlogin2.qq.com/login?ptlang=2052&amp;aid=522005705&amp;daid=4&amp;u1=https%3A%2F%2Fmail.qq.com%2Fcgi-bin%2Flogin%3Fvt%3Dpassport%26vm%3Dwpt%26ft%3Dptlogin%26ss%3D%26validcnt%3D%26clientaddr%3D2198400585%40qq.com&amp;from_ui=1&amp;ptredirect=1&amp;h=1&amp;wording=%E5%BF%AB%E9%80%9F%E7%99%BB%E5%BD%95&amp;css=https://mail.qq.com/zh_CN/htmledition/style/fast_login148203.css&amp;mibao_css=m_ptmail&amp;[email&#160;protected]&amp;uin=2198400585&amp;[email&#160;protected]&amp;p=<strong>&nbsp;15A6FB7C3A0F0F12BE2BB2BFA52F7BDF</strong>&amp;verifycode=<strong>&nbsp;!BQI</strong>&amp;fp=loginerroralert&amp;action=2-6-30865&amp;g=1&amp;t=1&amp;dummy=&amp;js_type=2&amp;js_ver=10009</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwNDA1MS8yMDEzMDgvMDgwMDQxNTQtZDc4Y2M5Njg4NmM2NGRmMWFlMTJhNmVkMGVkMzFmMTQuanBn.jpg"></p>

<p>登录成功后返回的数据：</p>
<p>ptuiCB(‘0‘,‘0‘,‘https://ssl.ptlogin2.mail.qq.com/check_sig?pttype=1&amp;uin=2198400585&amp;service=login&amp;nodirect=0&amp;ptsig=9mgQ2dwnOftcwH965zksFLFPidMP2zxKQZJXkxdfOy0_&amp;s_url=https%3a%2f%2fmail.qq.com%2fcgi-bin%2flogin%3fvt%3dpassport%26vm%3dwpt%26ft%3dptlogin%26ss%3d%26validcnt%3d%26clientaddr%3d2198400585%40qq.com&amp;f_url=&amp;ptlang=2052&amp;ptredirect=101&amp;aid=522005705&amp;daid=4&amp;j_later=0&amp;low_login_hour=0&amp;regmaster=0‘,‘1‘,‘登录成功！‘, ‘QQ‘);</p>


<p>分析以上两种方法，采用非对称式（公/私钥）加密方法较为安全，已建议APP小组研发采用<strong>RSA非对称加密</strong><strong>，使用HTTPS实现登录</strong>。</p>

<p>http://www.cnblogs.com/findyou/p/3244917.html?utm_source=tuicool&amp;utm_medium=referral</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 23:43:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>APP账号密码传输安全分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aDqanM.html" rel="bookmark">对登录中账号密码进行加密之后再传输的爆破的思路和方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 概述 渗透测试过程中遇到web登录的时候,现在很多场景账号密码都是经过js加密之后再请求发送(通过抓包可以看到加密信息)如图一burp抓到的包,request的post的登录包,很明显可以看到password参数的值是经过前端加密之后再进行传输的,遇到这种情况,普通发包的爆破脚本就很难爆破成功.鉴于这种情况,这边分析四种方式进行绕过加密爆破. 二. 方法和思路 1. 分析找出是哪个js文件进行了password参数值的加密,将该js导入本地动态执行,建一个小型的web服务器,利用浏览器页面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AmVNa4.html" rel="bookmark">利用SharedPreferences完成记住账号密码的功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用SharedPreferences完成记住账号密码的功能 效果图: 记住密码后,再次登录就会出现账号密码,否则没有. 分析: SharedPreferences可将数据存储到本地的配置文件中 SharedPreferences会记录CheckBox的状态,如果CheckBox被选,则将配置文件中记录的账号密码信息回馈给账号密码控件,否则清空. SharedPreferences使用方法: 1.创建名为config的配置文件,并且私有 private SharedPreferences con			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPBRWz3.html" rel="bookmark">archive成功了，但是在输出ipa时要求有账号密码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				archive成功了,但是在输出ipa时要求有账号密码 可以通过命令行方式输出,绕开账号检查1.进入Windows-Organizer-Archives,找到要输出的scarchive列表项:2.右键点击它,选择[Show in Finder]:3.右键点击.xcarchive文件,选择[显示包内容]:4.依次进入子目录 Products-Applications-找到你的目标文件,它其实是一个.app文件(目录):5.使用Go2Shell打开终端,进入该文件所在的目录:(也可以手动cd进入)6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWvkZl4.html" rel="bookmark">493万Gmail用户的账号密码遭泄露，疑从其他网站数据库提炼而成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				据国外媒体报道,周二近493万的Gmail用户账号和密码被发布到了俄罗斯的比特币论坛上.发布这些账号密码的比特币论坛用户,表示这其中约60%是有效的.不过谷歌公司并不认为Gmail有任何安全漏洞. 谷歌方面发言人表示,目前并没有证据表明,谷歌的系统被入侵过.一旦发现任何帐户有可能已经受到安全威胁,谷歌方面将会采取适当措施对其进行保护.同时,谷歌建议用户启用两步验证,并给出建议 “不管你是否是在名单上,换掉你的密码,以防万一.” 随后,论坛的管理员对这些账号中的文本内容进行了清理,只留下了用户名等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vW1gg4.html" rel="bookmark">WPF-本地保存登录账号密码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				WPF-本地保存登录账号密码 在登录界面,记住账号密码,当然,前提是正确的账号和密码. App.config 在App.config文件,&lt;configuration&gt;中添加以下代码,其中key是键,value是具体保存的值,在这声明了三个,分别是账号.密码和是否记住的bool属性 1 &lt;appSettings&gt; 2 &lt;add key=&quot;userName&quot; value=&quot;&quot;/&gt; 3 &lt;add key=&quot;passwo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX2e8b3.html" rel="bookmark">APP手势密码绕过</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前写的文章收到了很多的好评,主要就是帮助到了大家学习到了新的思路.自从发布了第一篇文章,我就开始筹备第二篇文章了,最终打算在07v8首发,这篇文章我可以保障大家能够学习到很多思路.之前想准备例子视频,请求了很多家厂商进行授权,但是涉及漏洞信息方面的,厂商都是很严谨的,所以,整个过程没有相关的实际例子,但是我尽可能的用详细的描述让大家能够看得懂.大家不要睡着呦~ 说到APP手势密码绕过的问题,大家可能有些从来没接触过,或者接触过,但是思路也就停留在那几个点上,这里我总结了我这1年来白帽子生涯当中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bGGjo3.html" rel="bookmark">注册邮箱账号十大品牌分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				电子邮箱是指通过互联网作特点.现在电子邮箱已经***到了我们工作,生活的每一个角落,电子邮箱已经无所不在为渠道发送和接收邮件的工具,电子邮箱具有快速.环保.安全.便利.多媒体等多种.相对于个人用户来说,一般使用的是互联网公司免费提供的电子邮箱.下面为大家介绍一些流行的.实用的.安全的.稳定的.可靠的.大容量的免费电子邮箱. 电子邮箱 常见的免费电子邮箱有哪些 1.谷歌电子邮箱(Gmail) Google提供的免费电子邮箱,第一个推出G级别电子邮箱的公司. 优点:目前提供15 GB的免费存储空间.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/N4pg7w3.html" rel="bookmark">c&num;登录时保存账号密码到cookie</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				登陆界面有用户名.密码输入框,一个’记住账号密码‘的复选框. 1.登录时,勾选‘记住账号密码‘复选框,则会把用户名密码保存在客户端cookie里,保存时间为最大值(直到用户清除浏览器缓存或者取消勾选’记住账号密码‘复选框): 2.登录时,取消勾选‘记住账号密码‘复选框,会清除cookie保存的用户名密码. 3.登录时,当修改了用户名密码,会判断cookie保存的值是否与输入的相同,如果不同,则会修改cookie的值. 4.登录时,当勾选了‘记住账号密码‘复选框,下次打开登录界面,‘记住账号密码‘			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMzr7kM.html" rel="bookmark">最近开始努力学python  写了一个python小代码：判断一个登陆程序，如果账号密码输错3次，锁定账号无法再登陆</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 count = 0 2 username = 'zhangsan' 3 userpassword = '111111' 4 5 f = open('lock.txt','r+') 6 file_list = f.readlines() 7 f.close() 8 #打开文件夹 读取数据 9 10 name = input(&quot;请输入用户名:&quot;) 11 12 if name in file_list: 13 print(&quot;您的账号被锁定!&quot;) 14 #判断文件夹中的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDv883.html" rel="bookmark" class="title">Jersey&lpar;1&period;19&period;1&rpar; - Hello World&comma; Get started with Jersey using the embedded Grizzly server</a>
					<div>
						Maven Dependencies The following Maven dependencies need to be added to the pom: &lt;dependency&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0nYDXM.html" rel="bookmark" class="title">MS SQL SERVER&colon; msdb&period;dbo&period;MSdatatype&lowbar;mappings &amp;amp&semi; msdb&period;dbo&period;sysdatatypemappings</a>
					<div>
						--SQL转Oracle/DB2的类型对应关系SELECT *FROM msdb.dbo.MSdatatype_mappings; --MS SQL SERVER更详细得显示了ORACLE/DB2各个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4poKo3.html" rel="bookmark" class="title">Linux入门进阶第二天&mdash;&mdash;软件安装管理（上）</a>
					<div>
						一.大纲介绍 二.简介 软件包分类: 源码包: 二进制包:(源码包编译后的包,将不能再看到源代码) MySQL PhP等开发环境的搭建比较麻烦 更详细的封装类型介绍: 软件包的封装类型 1.RPM软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEV5Z0.html" rel="bookmark" class="title">分治&mdash;&mdash;合并排序</a>
					<div>
						分治策略中有一个经典的算法就是合并排序,这个算法的精髓也是分治二字,分而治之.将一个大规模的问题分割成若干个同样的小问题,小问题的规模很小,很容易解决,解决了小的问题后再对这些小问题的结果进行合并得到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGmvbM.html" rel="bookmark" class="title">关于自动化测试环境的集成&lpar;Jenkins&plus;RobotFramework&plus;TestLink&plus;SVN&rpar;</a>
					<div>
						本人主要从事网络安全产品的测试,由于一些产品功能在后期稳定后每个版本的迭代仍需要投入大量的时间和精力去测试,所以近期计划逐步的去了解自动化测试的一些内容来节省和解放一些资源.由于自己并没有什么编码基础 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5XD53.html" rel="bookmark" class="title">散列技术之链地址法&lpar;基于无序链表&rpar;</a>
					<div>
						源码例如以下: #include &lt;stdlib.h&gt; #include &lt;stdio.h&gt; #define hash(v,M) (v % M) typedef char Ke ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bdO1M.html" rel="bookmark" class="title">python第二十四天-----作业终于完成啦</a>
					<div>
						1 #!usr/bin/env python 2 #-*-coding:utf-8-*- 3 # Author calmyan 4 #日志记录相关函数 5 import os,logging,time ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRWJV0.html" rel="bookmark" class="title">hdu 1392（凸包）</a>
					<div>
						传送门:Surround the Trees 题意:求凸包的周长. 分析:凸包模板题,先按极角排好序后,然后根据叉积正负确定凸包. #include &lt;stdio.h&gt; #include  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M628JyM.html" rel="bookmark" class="title">nodejs 单元测试</a>
					<div>
						之前项目开发因为改进度,基本都是粗放式开发.为了提高代码质量,单元测试是必不可少的. 针对restful api ,用supertest 测试框架.针对nodejs,引入mocha 和should 可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYGZv4.html" rel="bookmark" class="title">CSS3 Flex布局 Flexbox的属性详解</a>
					<div>
						原文:A Visual Guide to CSS3 Flexbox Properties Flex布局官方称为CSS Flexble Box布局模型是CSS3为了提高元素在容器中的对齐.方向.顺序,甚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvj1j4.html" rel="bookmark" class="title">Datazen安装</a>
					<div>
						Datazen是被微软收购的移动端全平台的数据展现解决方案.此篇主要介绍其安装过程. 下载页面,需要留意一下的是目前还没有中文版: http://www.datazen.com/start/ 点击Do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZklG0.html" rel="bookmark" class="title">：校园欺凌情况已d</a>
					<div>
						张德江参加审议 在郴州市召开村(居)&quot;两委&quot;换届选举培训工作会议后,永兴县立即对全县村(居)&quot;两委&quot;换届风气监督工作进行了安排部署,制订了&lt;永兴县村(居) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AANJg4.html" rel="bookmark" class="title">VMWare虚拟机提供的桥接、nat和主机模式的区别</a>
					<div>
						VMWare提供三种工作模式桥接(bridge).NAT(网络地址转换)和host-only(主机模式). 桥接模式 在桥接模式下,VMWare虚拟出来的操作系统就像是局域网中的一台独立的主机(主机和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022Aea0.html" rel="bookmark" class="title">Swift 2&period;0学习笔记（Day 19）&mdash;&mdash;函数参数传递</a>
					<div>
						原创文章,欢迎转载.转载请注明:关东升的博客   函数的语法格式如下: func 函数名(参数列表) -&gt; 返回值类型 { 语句组 return 返回值 } 关键字是func. 多个参数列表之间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkvGx3.html" rel="bookmark" class="title">Android之View &sol; SurfaceView &sol; GLSurfaceView</a>
					<div>
						Android游戏当中主要的除了控制类外就是显示类View.SurfaceView是从View基类中派生出来的显示类.android游戏开发中常用的三种视图是:view.SurfaceView和GLS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDpkX0.html" rel="bookmark" class="title">SQL SERVER 分页方法</a>
					<div>
						    最近项目中需要在SQL SERVER中进行分页,需要编写分页查询语句.之前也写过一些关于分页查询的语句,但是性能不敢恭维.于是在业务时间,在微软社区Bing了一篇老外写的关于SQL SERVE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxKqdM.html" rel="bookmark" class="title">Juniper Alarms 灯红色报警处理</a>
					<div>
						1.2.5.1告警查看 root# run show system alarms 2 alarms currently active Alarm time Class Description 2015 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmQVmYM.html" rel="bookmark" class="title">Iterator和List的一些问题</a>
					<div>
						1.iterator是有remove方法的,并且在使用iterator的过程中,不能自行调用collection的增删改方法 而可以利用iterator的remove方法来删除. 2.list就是一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynGLn0.html" rel="bookmark" class="title">shell 脚本远程复制文件</a>
					<div>
						!/bin/bash #vim ip.txt server ip ip_array=$(cat /tmp/ip.txt) for ip in ${ip_array[*]} do scp -P6122  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k2bnjM.html" rel="bookmark" class="title">激活、复制、使用R&sol;3标准数据源&lpar;RSA5、RSA6、RSA1&rpar;</a>
					<div>
						声明:原创作品,转载时请注明文章来自SAP师太技术博客:www.cnblogs.com/jiangzhengjun,并以超链接形式标明文章原始出处,否则将追究法律责任!原文链接:http://www. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
